/* File mparser.mly --- the lambda calculus */
/* Stephanie Weirich, adapted from code by Amr Sabry */

%token LAMBDA LPAREN RPAREN PLUS TIMES MINUS LET
%token <string>ID
%token <int> NUMBER

%start main
%type <Absyn.exp> main

%%

main: 
          exp { $1 }
;

exp: 
          ID { Absyn.Var ($1) }
        | LPAREN LAMBDA LPAREN ID RPAREN exp RPAREN 
				{ Absyn.Lambda ($4, $6) }
        | LPAREN exp exp RPAREN { Absyn.App ($2,$3) }
		  | NUMBER { Absyn.Num ($1) }
		  | LPAREN prim exps RPAREN { Absyn.Prim ($2, $3) }
		  | LPAREN LET LPAREN ID exp RPAREN exp RPAREN 
				{ Absyn.Let ($4,$5,$7) } 
;
/*
binds:   { [] }
	     | LPAREN ID exp RPAREN binds { ($2,$3)::$5 }
; */

prim:     PLUS  { Absyn.Plus  }
        | TIMES { Absyn.Times }
        | MINUS { Absyn.Minus }
;

exps:   /* empty */ { [] } 
        | exp exps  { ($1 :: $2) }
;
%%

