open Absyn

(* Sets and dictionaries in the library are implemented using balanced binary 
 * trees. Anything to be stored in such sets or used as keys in such dictionaries
 * needs to have a comparison function associated with it. *)

module VarType = struct
  type t = var
  let compare = Pervasives.compare 
end 

(* The a module for sets of variables. 
 * See http://caml.inria.fr/ocaml/htmlman/libref/Set.S.html 
 * for the operations provided on sets *)

module VarSet = Set.Make (VarType)

(* An abbreviation for the type of variable sets. *)
type set = VarSet.t

(* This exception should be raised in 
 * part 5 when an expression cannot be evaluated. *)
exception RuntimeError of string

(* This exception should not appear in the code that you submit.  It
 *	is only used now so that you can run and test the program before
 *	completing the assignment. *)
exception TODO 

(* A function to print all of the vars contained in a set, with 
 * spaces between each variable. *)
let print_vars (vs:set) : unit = 
  let es = VarSet.elements vs in 
  Format.open_hbox();
  Absyn.print_list es Format.print_string Format.print_space;
  Format.close_box();
  Format.print_newline()


(*********************************************************************)
(* This is the part you need to write *)

(* 1 *)

let rec bound_vars (exp:exp) : set = raise TODO

let free_vars (exp:exp) : set = raise TODO

(* 2 *)

let is_closed (exp:exp) :bool = raise TODO

(* 3 *)

let rec subst  (subst_exp:exp) (subst_var:var) (exp:exp) : exp = raise TODO

(* 4 *)
					
let rec eval (exp:exp) : exp = raise TODO

(* 5 *) 

let rec is_aeq (exp1:exp) (exp2:exp) : bool = raise TODO


